#version 330

in vec3 fPos;
in vec3 fNormal;

uniform vec3 lightPos;
uniform vec3 viewPos;
uniform vec3 lightColor;
uniform vec4 objectColor;

out vec4 fColor;

void main()
{
    // ambient
    float ambientStrength = 0.2;
    vec3 ambient = ambientStrength * lightColor;

    // diffuse
    vec3 norm = normalize(fNormal);
    // vec3 xTangent = dFdx( fPos );
    // vec3 yTangent = dFdy( fPos );
    // vec3 norm = normalize( cross( xTangent, yTangent ) );
    vec3 lightDir = normalize(lightPos - fPos);
    float diff = max(dot(norm, lightDir), 0.0);
    vec3 diffuse = diff * lightColor;

    // specular
    float specularStrength = 0.3;
    vec3 viewDir = normalize(viewPos - fPos);
    vec3 reflectDir = reflect(-lightDir, norm);
    float spec = pow(max(dot(viewDir, reflectDir), 0.0), 2);
    vec3 specular = specularStrength * spec * lightColor;
    specular = clamp(specular, 0.0, 1.0);

    fColor = vec4((ambient + diffuse + specular),1) * objectColor;
    // fColor = objectColor;
}